"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaultTarget = '_blank';
var defaultUrlRegExp = new RegExp(['^(https?:\/\/(?:www\.|(?!www))[a-zA-Z0-9][a-zA-Z0-9-]+[a-zA-Z0-9]\.',
    '[^\s]{2,}|www\.[a-zA-Z0-9][a-zA-Z0-9-]+[a-zA-Z0-9]\.',
    '[^\s]{2,}|https?:\/\/(?:www\.|(?!www))[a-zA-Z0-9]+\.',
    '[^\s]{2,}|www\.[a-zA-Z0-9]+\.[^\s]{2,})$'].join(''));
;
function defineOptions(options) {
    var validUrlRegExp = options.urlRegEx ? options.urlRegEx : defaultUrlRegExp;
    var aTarget = options.target ? options.target : defaultTarget;
    return { validUrlRegExp: validUrlRegExp, aTarget: aTarget };
}
;
function updateLinkedPhrase(nEnd, linkedPhrase, newText) {
    if (nEnd) {
        return linkedPhrase + newText + '\n';
    }
    return linkedPhrase + newText;
}
function updateHTMLWithLinks(el, bind, vnode, options) {
    var opts = options ? options : {};
    var _a = defineOptions(opts), validUrlRegExp = _a.validUrlRegExp, aTarget = _a.aTarget;
    var text = vnode.children ? vnode.children[0].text : undefined;
    if (!text) {
        console.error("v-dolinks directive couldn't find text inside of <".concat(vnode.tag, "> tag.\n"), "v-dolinks should be used directly on tags, which contains text");
    }
    var spaceSplitedText = text.split(' ');
    var linkedTextArr = spaceSplitedText.map(function (word) {
        var nSplitedPhrase = word.split(/\n/);
        var nEnd = nSplitedPhrase.length > 1 ? nSplitedPhrase.length : 0;
        var nSplitedPhraseLinked = '';
        for (var _i = 0, nSplitedPhrase_1 = nSplitedPhrase; _i < nSplitedPhrase_1.length; _i++) {
            var nSplitedTerm = nSplitedPhrase_1[_i];
            nEnd -= 1;
            var isTermALink = nSplitedTerm.match(validUrlRegExp);
            if (isTermALink) {
                var linkEl = "<a href=\"".concat(nSplitedTerm, "\" target=\"").concat(aTarget, "\">").concat(nSplitedTerm, "</a>");
                nSplitedPhraseLinked = updateLinkedPhrase(nEnd, nSplitedPhraseLinked, linkEl);
                continue;
            }
            nSplitedPhraseLinked = updateLinkedPhrase(nEnd, nSplitedPhraseLinked, nSplitedTerm);
        }
        return nSplitedPhraseLinked;
    });
    el.innerHTML = linkedTextArr.join(' ');
}
exports.default = updateHTMLWithLinks;
